#include "mex.h"
#include "ANN.h"
#include <fstream>
#include <iostream>
using namespace std;

#define MAX_FILENAME_LENGTH  512

// This is the MEX implementation of the MATLAB function 'annkdtree_save'.
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
    // Verify the correctness of the number of input and output parameters as well as their type:
    if(nlhs != 0 || nrhs != 2 || !mxIsChar(prhs[1])) mexErrMsgTxt("Incorrect Sintax\n\tannkdtree_save(tree, treeFileName)\n");

    // Get pointer to the input kd-tree:
    double* pointer0 = mxGetPr(prhs[0]);
    long    pointer1 = (long) pointer0[0];
    ANNkd_tree* tree = (ANNkd_tree*) pointer1;
    
    // Get the name of the file with the kd-tree:
    char treeFileName[MAX_FILENAME_LENGTH];
    mxGetString(prhs[1], treeFileName, MAX_FILENAME_LENGTH);
    
    // Save the kd-tree:
	static ofstream treeFile;
    treeFile.open(treeFileName, ios::out);
    if(!treeFile)
    {
        char errorMsg[128];
        sprintf(errorMsg, "Couldn't open file: %s\n", treeFileName);
        mexErrMsgTxt(errorMsg);
    }
	tree->Dump(ANNtrue, treeFile);
    
    treeFile.close();
}
